function Create(self)
--The timer that will measure out the missile's events.
    self.LTimer = Timer();

--The missile's target, currently set to nothing.
	self.target = nil;

--Find out who shot the weapon by finding the closest actor within 50 pixels.
    local curdist = 50;
    for actor in MovableMan.Actors do
		local avgx = actor.Pos.X - self.Pos.X;
		local avgy = actor.Pos.Y - self.Pos.Y;
		local dist = math.sqrt(avgx ^ 2 + avgy ^ 2);
		if dist < curdist then
			curdist = dist;
			self.parent = actor;
		end
    end
    
    print("Missile fired");

--If the missile has no firer, make it go after anyone.  Otherwise, set its team to that of the firer.
    if MovableMan:IsActor(self.parent) then
		self.Team = self.parent.Team;
		
		-- MORay is very accurate so you need to aim carefully to catch something
		-- that's ok with large vessels but it can make harder to hit actors
		-- Thats why we need to make three rays which make 10 degrees scanning ray
		-- first we try direct hit, then +- 5 degrees rays
		local angle = self.parent:GetAimAngle(true);
		local wideangle = {};
		local targetfound = false;

		wideangle[1] = angle;
		wideangle[2] = angle - 0.088; -- Angle in radians
		wideangle[3] = angle + 0.088;
		
		--Start scanning
		for i = 1,3 do
			-- When creating starting point for scanning ray we need it to be outside of firing actor
			-- or CastMORay will detect firing actor and make it target. Targets closer than 90 pixels will
			-- be ignored
			local raystartvector = self.parent.Pos - Vector( -math.cos(wideangle[i]) * 90 , math.sin(wideangle[i]) * 90);
			-- Offset for CastMORay , it don't need to know acrot position, only angles
			-- 750 is the length of scanning ray
			local rayendvector = Vector( math.cos(wideangle[i]) * 750 , - math.sin(wideangle[i]) * 750);
			
			-- Cast ray and get id of MO hit by ray
			local moid = SceneMan:CastMORay(raystartvector , rayendvector , 0 , 0 , false , 3);
			
			-- SceneMan.g_NoMOID returned if we hit ground or hit nothing
			if moid ~= SceneMan.g_NoMOID then
				-- Get MO object from stored id
				local mo = MovableMan:GetMOFromID(moid);

				-- Always check if found object is still alive
				if mo ~= nil then
					-- Find wich actor found MO belong to
					for actor in MovableMan.Actors do
						if mo.RootID == actor.ID then
							self.target = actor;
							self.target:FlashWhite(50);
							targetfound = true;
							break;
						end
					end --for
				end --if
			end --if
			if targetfound then
				break;
			end
		end --for
    else
		self.Team = -1;
    end
end

function Update(self)
    if self.LTimer:IsPastSimMS(500) then
		--If the target still exists...
		if MovableMan:IsActor(self.target) then
			--The direction from the center of the missile to the target.
			local targetdir = math.atan2(-(self.target.Pos.Y - self.Pos.Y) , (self.target.Pos.X - self.Pos.X));

			--Gradually angle the missile toward its target.
			if targetdir ~= self.RotAngle then
			self.RotAngle = targetdir;
			end

			--Make sure the missile's thruster is firing.
			if self:IsEmitting() == false then
				self:EnableEmission(true);
			end
		else
			--If there's no target, shut off the thrusters.
			--if self:IsEmitting() == true then
			--    self:EnableEmission(false);
			--end
		end

		if self.LTimer:IsPastSimMS(6500) then
			--If the missile has run out of time, self destruct!
			self:GibThis();
		end
    end
end